package jp.sourceforge.cfneo.at4ie.api.impl.ie.invoker;

import jp.sourceforge.cfneo.at4ie.api.AT4IEAssertException;
import jp.sourceforge.cfneo.at4ie.api.Context;
import jp.sourceforge.cfneo.at4ie.api.ElementLocatorEnum;
import jp.sourceforge.cfneo.at4ie.api.Invoker;
import jp.sourceforge.cfneo.at4ie.api.TargetBrowser;
import jp.sourceforge.cfneo.at4ie.api.TestCase;
import jp.sourceforge.cfneo.at4ie.utils.LocatorUtil;

import org.apache.log4j.Logger;

/**
 * command=assertValueのInvoker。<br />
 * 指定されたLocatorのValueを検証する。
 * @author imaitakafumi
 *
 */
public class AssertValueInvoker extends Invoker {

	Logger logger = Logger.getLogger(AssertValueInvoker.class);

	/**
	 * コンストラクタ。
	 * @param context
	 * @param browser
	 */
	public AssertValueInvoker(Context context, TargetBrowser browser) {
		super(context, browser);
	}

	@Override
	public void invoke(TestCase testCase) throws AT4IEAssertException {
		ElementLocatorEnum elem = LocatorUtil.getElementLocatorEnum(testCase.getTarget());
		String expected = LocatorUtil.getLocatorValue(testCase.getValue());
		logger.debug("expected=" + expected);
		String actual = null;
		logger.debug("elem=" + elem.toString());
		switch (elem) {
		case DOM:
			break;
		case ID:
			actual = super.getBrowser().getTextValueById(testCase.getElementValue());
		case IDENTIFIER:
			break;
		case LINK:
			break;
		case NAME:
			actual = super.getBrowser().getTextValueByName(testCase.getElementValue());
			break;
		case XPATH:
			break;
		case VALUE:
			break;
		case OTHER:
			if ("title".equals(testCase.getTarget())) {
				actual = super.getBrowser().getScreenTitle();
			}
			break;
		}
		logger.debug("AssertAlertInvoker#invoke testCase=" + testCase.toString()
				+ " expected=[" + expected + "]/actual=[" + actual + "]");
		if (expected.equals(actual) == false) {
			throw new AT4IEAssertException(testCase.getElementValue(), actual);
		}
	}

}
